import { __rest, __assign } from 'tslib';
import * as React from 'react';
import { useEffect } from 'react';
import { motion } from '../render/dom/motion.mjs';
import { useMotionValue } from '../value/use-motion-value.mjs';
import { useVisualElementContext } from '../context/MotionContext/index.mjs';
import { calcLength } from '../projection/geometry/delta-calc.mjs';

function LayoutSVGComponent(_a, ref) {
    var children = _a.children, props = __rest(_a, ["children"]);
    var viewBox = useMotionValue(props.viewBox);
    return (React.createElement(motion.svg, __assign({ ref: ref }, props, { viewBox: viewBox, layout: true, preserveAspectRatio: "none" }),
        React.createElement(ProjectViewBox, { viewBox: viewBox }),
        children));
}
function ProjectViewBox(_a) {
    var viewBox = _a.viewBox;
    var svgVisualElement = useVisualElementContext();
    useEffect(function () {
        var _a;
        return (_a = svgVisualElement === null || svgVisualElement === void 0 ? void 0 : svgVisualElement.projection) === null || _a === void 0 ? void 0 : _a.addEventListener("projectionUpdate", function (_a) {
            var x = _a.x, y = _a.y;
            // TODO: A reveal option could be added where 0 0 is
            // x.min, y.min
            // viewBox.set(`0 0 ${calcLength(x)} ${calcLength(y)}`)
            viewBox.set("".concat(x.min, " ").concat(y.min, " ").concat(calcLength(x), " ").concat(calcLength(y)));
        });
    }, [svgVisualElement]);
    return null;
}
var LayoutSVG = React.forwardRef(LayoutSVGComponent);

export { LayoutSVG, LayoutSVGComponent };
